#pragma once

#include "IMessage.h"
#include "Thing.h"

namespace RoboidControl {

/// @brief Message to request details for a Thing
class InvestigateMsg : public IMessage {
 public:
  /// @brief The message ID
  static const unsigned char id = 0x81;
  /// @brief The length of the message
  static const unsigned char length = 3;
  /// @brief The network ID of the thing
  unsigned char networkId;
  /// @brief the ID of the thing
  unsigned char thingId;

  /// @brief Create an investigate message
  /// @param networkId The network ID for the thing
  /// @param thing The thing for which the details are requested
  InvestigateMsg(unsigned char networkId, Thing* thing);
  /// @copydoc RoboidControl::IMessage::IMessage(char*)
  InvestigateMsg(char* buffer);
  /// @brief Destructor for the message
  virtual ~InvestigateMsg();

  /// @copydoc RoboidControl::IMessage::Serialize
  virtual unsigned char Serialize(char* buffer) override;
};

}  // namespace RoboidControl
